import java.util.Collection;

import javax.persistence.EntityManager;

public class ProfessorService {
  protected EntityManager em;

  public ProfessorService(EntityManager em) {
    this.em = em;
  }

  public Professor createProfessor(int empId, String empName, int deptId) {
    Department dept = em.getReference(Department.class, deptId);
    Professor emp = new Professor();
    emp.setId(empId);
    emp.setName(empName);
    emp.setDepartment(dept);
    dept.getProfessors().add(emp);
    em.persist(emp);
    return emp;
  }

  public Collection<Professor> findAllProfessors() {
    return (Collection<Professor>) em.createQuery("SELECT e FROM Professor e").getResultList();
  }

  public Collection<Department> findAllDepartments() {
    return (Collection<Department>) em.createQuery("SELECT d FROM Department d").getResultList();
  }
}
